stages:
  - test
  - build
  - deploy

variables:
  PAGES_PREFIX: ""

.default-branch: &default-branch
  if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH 

.merge-request-only: &merge-request-only
  if: $CI_PIPELINE_SOURCE == 'merge_request_event'

.scheduled-pipeline: &scheduled-pipeline
  if: '$CI_PIPELINE_SOURCE == "schedule" && $SCHEDULED_DEPLOY == "true"'

test_m1:
  image: $IMAGE
  stage: test
  script:
    - ruby inspect.rb > content/$IMAGE.md
  tags:
    - saas-macos-medium-m1
  artifacts:
    paths:
      - content    
  parallel:
    matrix:
      - IMAGE: [macos-13-xcode-14, macos-14-xcode-15]
  rules:
    - <<: *default-branch
    - <<: *scheduled-pipeline
    - <<: *merge-request-only
        
build:
  image: registry.gitlab.com/pages/hugo/hugo_extended:0.136.5
  stage: build
  script:
    - git clone https://github.com/adityatelange/hugo-PaperMod themes/PaperMod --depth=1
    - hugo --enableGitInfo
  variables:
    HUGO_BASEURL: https://gitlab-org.gitlab.io/incubation-engineering/mobile-devops/macos-runner-inspector/ 
  artifacts:
    paths:
      - public
  rules:
  - <<: *default-branch
  - <<: *scheduled-pipeline  
  - <<: *merge-request-only
    variables:
      PAGES_PREFIX: 'mr$CI_MERGE_REQUEST_IID'
      ENVIRONMENT: 'mr$CI_MERGE_REQUEST_IID'
      HUGO_BASEURL: "${CI_PAGES_URL}/${PAGES_PREFIX}"

pages:
  stage: deploy
  environment:
    name: $ENVIRONMENT
    deployment_tier: production
    url: $HUGO_BASEURL
  variables:
    ENVIRONMENT: production
    HUGO_BASEURL: https://gitlab-org.gitlab.io/incubation-engineering/mobile-devops/macos-runner-inspector/ 
  pages:
    path_prefix: "$PAGES_PREFIX"
  artifacts:
    paths:
      - public
  script:
    - echo "Pages accessible through ${CI_PAGES_URL}/${PAGES_PREFIX}"      
  rules:
    - <<: *default-branch
    - <<: *scheduled-pipeline
    - <<: *merge-request-only
      variables:
        PAGES_PREFIX: 'mr$CI_MERGE_REQUEST_IID'
        ENVIRONMENT: 'mr$CI_MERGE_REQUEST_IID'
        HUGO_BASEURL: "${CI_PAGES_URL}/${PAGES_PREFIX}"
